#  CMake configure file for alps-gf. Defines:
#  alps-gf_FOUND        - System has alps-gf
#  alps-gf_LIBRARIES    - The alps-gf libraries (external targets)
#  alps-gf_HAS_MPI      - The alps-gf is compiled with MPI enabled

# FIXME: is not affected by alps-gf_LIBRARY

foreach(dep_ alps-utilities;alps-hdf5)
  find_package(${dep_} PATHS ${CMAKE_CURRENT_LIST_DIR}/../${dep_} NO_DEFAULT_PATH)
endforeach()
unset(dep_)

include(${CMAKE_CURRENT_LIST_DIR}/alps-gf.cmake)

set(alps-gf_HAS_MPI TRUE)
set(alps-gf_LIBRARIES alps::alps-gf)

if (NOT ALPSCore_HAS_EIGEN_VERSION)
  set(ALPSCore_HAS_EIGEN_VERSION "3.4.0")
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(alps-gf DEFAULT_MSG alps-gf_LIBRARIES)
